【C++】滑动窗口:最大连续1的个数

1.题目

2.算法思路

其实在做这道题的时候并不需要真的把0翻转成1,只需要找到最长的子数组且该子数组中0的个数不大于K,就可以了!

当然我们首先想到的是暴力穷举法:

找到所有符合题意的子数组,跳出最长的那个就可以了。需要嵌套的两层循环,时间复杂度是O(N^2),对于一个在Leetcode上中等难度的题目来说大概率会运行超时,所以我们需要对暴力穷举法进行优化。

那么我们需要同向的双指针left和right来作为子数组的两个端点,用计数器size统计0的个数,用len来记录最大子数组的长度。

当size>K时->left++,这时right不用再回来,因为right回来后它还是会在原来的位置停下来(根据零的个数),所以我们需要不停的往右移动left,知道它越过一个0后停止。

上图是滑动窗口的具体解法步骤。

总结:

当一个题目是对一个区间进行判断,一般问最大最小等问题时往往用到滑动窗口。

再说一下:滑动窗口就是同向的双指针算法。

3.提交结果与代码实现

cpp 复制代码
class Solution {
public:
    int longestOnes(vector<int>& nums, int k) {
        int size=0,len=0;
        for(int left=-1,right=0;right<nums.size();right++){
            if(nums[right]==0) size++;//进窗口
            if(size<=k) len=max(len,right-left);//判断和更新结果
            while(size>k)
                if(nums[++left]==0) size--;//出窗口
            }
        return len;
    }
};

时间复杂度:O(N)。空间复杂度:O(1)。

相关推荐
dialect_5 小时前
KMP算法
开发语言·c++·算法
总要学点什么6 小时前
第89篇:三维特效-螺旋圆效果——让螺旋臂卷起一圈圈外扩的涟漪
开发语言·javascript·ecmascript·webgl·cesium·空间分析·1024程序员节
文丑颜不良啊6 小时前
LeetCode1481~1500题目解析
java·leetcode
ShineWinsu7 小时前
对于Qt:QRadioButton常见属性以及QButtonGroup的解析
数据库·c++·qt·microsoft·gui·qradiobutton·qbuttongroup
文丑颜不良啊7 小时前
LeetCode1381~1400题目解析
java·leetcode
傲世仙尊7 小时前
多态-虚表才活到运行期符号表早已消失
c++
开开心心_Every7 小时前
快速隐藏程序工具自定义快捷键一键切换
java·开发语言·前端·spring·智能手机·word·intellij-idea
chenbingjie_c8 小时前
C++ 多态完全指南:从虚函数重写到虚函数表原理
开发语言·c++
是main不是漫8 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
吴卫斌8 小时前
定投ETF实战指南(四):行业/主题ETF——定投的“进攻端“
开发语言·python·股票·量化